<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for POIResult StructType
 * @subpackage Structs
 */
class POIResult extends POI
{
    /**
     * The Groups
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfPOIGroup
     */
    public $Groups;
    /**
     * The ContactPerson
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\POIContactPerson
     */
    public $ContactPerson;
    /**
     * The OpeningHours
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\OpeningHours
     */
    public $OpeningHours;
    /**
     * The ExtraInformation
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ExtraInformation;
    /**
     * Constructor method for POIResult
     * @uses POIResult::setGroups()
     * @uses POIResult::setContactPerson()
     * @uses POIResult::setOpeningHours()
     * @uses POIResult::setExtraInformation()
     * @param \ArrayType\ArrayOfPOIGroup $groups
     * @param \StructType\POIContactPerson $contactPerson
     * @param \StructType\OpeningHours $openingHours
     * @param string $extraInformation
     */
    public function __construct(\ArrayType\ArrayOfPOIGroup $groups = null, \StructType\POIContactPerson $contactPerson = null, \StructType\OpeningHours $openingHours = null, $extraInformation = null)
    {
        $this
            ->setGroups($groups)
            ->setContactPerson($contactPerson)
            ->setOpeningHours($openingHours)
            ->setExtraInformation($extraInformation);
    }
    /**
     * Get Groups value
     * @return \ArrayType\ArrayOfPOIGroup|null
     */
    public function getGroups()
    {
        return $this->Groups;
    }
    /**
     * Set Groups value
     * @param \ArrayType\ArrayOfPOIGroup $groups
     * @return \StructType\POIResult
     */
    public function setGroups(\ArrayType\ArrayOfPOIGroup $groups = null)
    {
        $this->Groups = $groups;
        return $this;
    }
    /**
     * Get ContactPerson value
     * @return \StructType\POIContactPerson|null
     */
    public function getContactPerson()
    {
        return $this->ContactPerson;
    }
    /**
     * Set ContactPerson value
     * @param \StructType\POIContactPerson $contactPerson
     * @return \StructType\POIResult
     */
    public function setContactPerson(\StructType\POIContactPerson $contactPerson = null)
    {
        $this->ContactPerson = $contactPerson;
        return $this;
    }
    /**
     * Get OpeningHours value
     * @return \StructType\OpeningHours|null
     */
    public function getOpeningHours()
    {
        return $this->OpeningHours;
    }
    /**
     * Set OpeningHours value
     * @param \StructType\OpeningHours $openingHours
     * @return \StructType\POIResult
     */
    public function setOpeningHours(\StructType\OpeningHours $openingHours = null)
    {
        $this->OpeningHours = $openingHours;
        return $this;
    }
    /**
     * Get ExtraInformation value
     * @return string|null
     */
    public function getExtraInformation()
    {
        return $this->ExtraInformation;
    }
    /**
     * Set ExtraInformation value
     * @param string $extraInformation
     * @return \StructType\POIResult
     */
    public function setExtraInformation($extraInformation = null)
    {
        // validation for constraint: string
        if (!is_null($extraInformation) && !is_string($extraInformation)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($extraInformation, true), gettype($extraInformation)), __LINE__);
        }
        $this->ExtraInformation = $extraInformation;
        return $this;
    }
}
